#include <cstdlib>
#include <ctime>
#include <string>
#include <limits>
using namespace std;


struct Question{
	string q;
	string ans;
};
Question questions[5] = {
	{"Процесс создания компьютерной программы", "programming"},
	{"Процесс поиска и устранения ошибок в программе", "debugging"},
	{"Конечный набор шагов, которые при следовании им решают какую-то задачу", "algorithm"},
	{"Именованные ячейки памяти, которые используются для хранения данных программы", "variables"},
	{"Языковая конструкция, которая может определять участок программы для многократного повторения", "loop"}
};
struct Responce{
	char* word;
	bool is_fiend;
};


// Определить длинну строки (length() работает не корректно с русскими символами)
size_t strlen(string str) {
    size_t size = 0;
    for (auto byte : str) {
        size += (((byte & 0x80) == 0) || ((byte & 0xC0) == 0xC0));
    }
    return size;
}

// Найти букву в слове
Responce find_letter(char letter, char* guessed_word, string word);

// Сгенерировать букву
char gen_symbol(char* guessed_word, string word);



void game4(){
	srand(time(0));


	char gamers[3][7] = {
		"User ",
		"Bot 1 ",
		"Bot 2 "
	};

	// Создаём очерёдность
	int priority[3]; // очерёдность 0 - юзер, 1,2 - боты
	for(int i=0; i<3; i++){
		int rand_val = rand()%3;
		if(i==1 && priority[0] != rand_val){
			priority[i] = rand_val;
		}else if(i==2 && priority[0] != rand_val && priority[1] != rand_val){
			priority[i] = rand_val;
		}else if(i==0){
			priority[i] = rand_val;
		}else{
			i--;
		}
	}

	// Вывоим очерёдность
	cout << "Очерёдеость: ";
	for(int i=0; i<3; i++){
		cout << gamers[priority[i]];
	}
	cout << endl;

	// определяем и выводим вопрос и звёздочки ответа
	Question selected_ques = questions[rand()%6];
	char *guessed_word = new char[strlen(selected_ques.ans)+1];
	for(int i=0; i<strlen(selected_ques.ans); i++){
		guessed_word[i] = '*';
	}
	cout << "Вопрос: " << selected_ques.q << "\nЗагаданное слово: " << guessed_word << endl;

	// Крутим барабан
	int scores[3] = {0, 0, 0};
	while((string)guessed_word != selected_ques.ans){
		for (int i = 0; i < 3; i++){
			int score = rand()%1000;
			cout << endl << gamers[priority[i]] << " крутит барабан... \n" << score << " очков на барабане\n";
			if(score == 0)
				continue;
			scores[i] += score;
			
			cout << "Буква/слово: ";
			if(priority[i] == 0){
				cin.clear(); // очищаем буфер
	        	cin.ignore(numeric_limits<streamsize>::max(), '\n');
				// Пока в буфере есть символы проверяем их на соответствие
				while(cin.peek() != '\n'){
					char x;
					cin >> x;
					Responce resp = find_letter(x, guessed_word, selected_ques.ans);
					guessed_word = resp.word;
					if(resp.is_fiend) // Если буква правильная, то возвращаемся на 1 иттерацию, т.е. к тому же игроку
						i--;
				}
			}else{
				// Генерируем символ и проверяем его
				char letter;
				letter = gen_symbol(guessed_word, selected_ques.ans);
				Responce resp = find_letter(letter, guessed_word, selected_ques.ans);
				guessed_word = resp.word;
				if(resp.is_fiend)
					i--;
			}
			
			cout << "Слово: " << guessed_word << endl;
			
			// Если слово отгаданно, то выходим из цикла
			if((string)guessed_word == selected_ques.ans)
				break;
		}
	}
	// Выводим очки
	cout << endl << "Очки: ";
	for (int i = 0; i < 3; ++i){
		cout << gamers[priority[i]] << " : " << scores[i] << "; ";
	}
	cout << endl;
}


Responce find_letter(char letter, char* guessed_word, string word){
	bool is_fiend = false;
	for (int i = 0; i < strlen(word); ++i){
		if(letter == word[i]){
			guessed_word[i] = letter;
			is_fiend = true;
		}
	}
	return {guessed_word, is_fiend};
}


// Массив английских букав
char letters[] = "abcdefghijklmnopqrstuvwxyz";


// Сгенерировать букву
char gen_symbol(char* guessed_word, string word){
	char symbol = letters[rand() % 26]; // Символ из массива
	cout << symbol << endl;
	bool regenerate = false;
	// Проверяем, нет ли данного символа в отгаданном слове, если есть, то генерируем заново
	for (int i = 0; i < strlen(word); ++i){
		if(guessed_word[i] == symbol){
			regenerate = true;
		}	
	}
	if(regenerate){
		return gen_symbol(guessed_word, word);
	}else{
		return symbol;
	}
}

